image: gradle:7.5.1-jdk17-alpine

stages:          # List of stages for jobs, and their order of execution, also creates javadoc
  - build
  - test
  - deploy

building:       # This job runs in the build stage, which runs first.
  stage: build
  script:
    - gradle assemble

unit-tests:   # This job runs in the test stage.
  stage: test    # It only starts when the job in the build stage completes successfully.
  script:
    - gradle test

pages:
  stage: deploy
  script:
    - gradle javadoc
  artifacts:
    paths:
      - public
  only:
    - web

deployment:      # This job runs in the deployment stage.
  stage: deploy  # It only runs when *both* jobs in the test stage complete successfully.
  environment: production
  script:
    - gradle publish
  only:
    - web
